'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _extends = require('@babel/runtime/helpers/extends');
var _objectSpread = require('@babel/runtime/helpers/objectSpread2');
var _objectWithoutProperties = require('@babel/runtime/helpers/objectWithoutProperties');
var core = require('@westpac/core');
var react = require('react');
var PropTypes = require('prop-types');
require('@babel/runtime/helpers/defineProperty');
var body = require('@westpac/body');

function _interopDefault (e) { return e && e.__esModule ? e : { 'default': e }; }

var PropTypes__default = /*#__PURE__*/_interopDefault(PropTypes);

var _excluded$g = ["state"];
// Component
// ==============================

var Wrapper = function Wrapper(_ref) {
  _ref.state;
      var rest = _objectWithoutProperties(_ref, _excluded$g);

  return core.jsx("div", rest);
}; // ==============================
// Styles
// ==============================


var wrapperStyles = function wrapperStyles() {
  var _useBrand = core.useBrand();
      _useBrand.COLORS;

  return {
    label: core.getLabel('table-wrapper'),
    '@media screen and (max-width: 480px)': {
      width: '100%',
      marginBottom: '1.125rem',
      overflowY: 'hidden',
      overflowX: 'auto'
    }
  };
}; // ==============================
// Attributes
// ==============================


var wrapperAttributes = function wrapperAttributes() {
  return null;
}; // ==============================
// Exports
// ==============================


var defaultWrapper = {
  component: Wrapper,
  styles: wrapperStyles,
  attributes: wrapperAttributes
};

var pkg = {
	name: "@westpac/table",
	version: "1.1.0",
	description: "Styling for tables, including two visual styles and row/cell highlighting, used for displaying tabular data",
	homepage: "https://gel.westpacgroup.com.au/design-system",
	repository: "https://github.com/WestpacGEL/GEL/tree/master/components/table",
	blender: {
		recipe: "blender/recipe.js"
	},
	components: [
		{
			name: "Table",
			src: "Table.js"
		},
		{
			name: "Td",
			src: "Td.js"
		},
		{
			name: "Tr",
			src: "Tr.js"
		},
		{
			name: "Caption",
			src: "Caption.js"
		},
		{
			name: "Thead",
			src: "Thead.js"
		},
		{
			name: "Th",
			src: "Th.js"
		},
		{
			name: "Tbody",
			src: "Tbody.js"
		},
		{
			name: "Tfoot",
			src: "Tfoot.js"
		}
	],
	author: "Westpac GEL Team <gel@westpac.com.au>",
	contributors: [
		{
			name: "Dominik Wilkowski",
			email: "Hi@Dominik-Wilkowski.com",
			url: "https://dominik-wilkowski.com"
		},
		{
			name: "Jonathan Stening",
			email: "info@jonathanstening.com",
			url: "http://jonathanstening.com"
		},
		{
			name: "Jeremy Ortiz",
			email: "jeremy@jeremyortiz.io",
			url: "https://www.jeremyortiz.io/"
		},
		{
			name: "Flore Laforge",
			email: "florelaforge@gmail.com",
			url: "http://florelaforge.com/"
		}
	],
	license: "GPL-3.0+",
	scripts: {
		start: "PACKAGE_NAME=table NODE_ENV=development webpack server --config ../../helpers/example/start.webpack.config.js",
		test: "exit 0 # start-server-and-test start http://localhost:8080 test:all",
		"test:dev": "start-server-and-test start http://localhost:8080 test:test-dev",
		"test:all": "yarn test:integration",
		"test:integration": "cypress run",
		"test:test-dev": "cypress open"
	},
	main: "dist/westpac-table.cjs.js",
	module: "dist/westpac-table.esm.js",
	dependencies: {
		"@babel/runtime": "^7.14.8",
		"@westpac/body": "^1.4.1",
		"@westpac/core": "^2.2.0",
		"prop-types": "^15.7.2"
	},
	peerDependencies: {
		react: "^17.0.2"
	},
	devDependencies: {
		cypress: "^8.0.0",
		react: "^17.0.2",
		"start-server-and-test": "^1.12.6"
	}
};

var _excluded$f = ["highlighted", "highlightStart", "bordered", "children", "overrides"];
// Component
// ==============================

var Td$1 = function Td(_ref) {
  var highlighted = _ref.highlighted,
      highlightStart = _ref.highlightStart,
      bordered = _ref.bordered,
      children = _ref.children,
      overrides = _ref.overrides,
      rest = _objectWithoutProperties(_ref, _excluded$f);

  var _useBrand = core.useBrand(),
      tokenOverrides = _useBrand.OVERRIDES[pkg.name],
      brandOverrides = _useBrand[pkg.name];

  var context = useTableContext();
  bordered = context && context.bordered || bordered;
  var defaultOverrides = {
    Td: defaultTd
  };
  var componentOverrides = overrides || context.state.overrides;

  var state = _objectSpread({
    highlighted: highlighted,
    highlightStart: highlightStart,
    bordered: bordered,
    context: context.state,
    overrides: componentOverrides
  }, rest);

  var _overrideReconciler = core.overrideReconciler(defaultOverrides, tokenOverrides, brandOverrides, componentOverrides),
      _overrideReconciler$T = _overrideReconciler.Td,
      Td = _overrideReconciler$T.component,
      tdStyles = _overrideReconciler$T.styles,
      tdAttributes = _overrideReconciler$T.attributes;

  return core.jsx(Td, _extends({}, rest, {
    state: state
  }, tdAttributes(state), {
    css: tdStyles(state)
  }), children);
}; // ==============================
// Types
// ==============================

Td$1.propTypes = {
  /**
   * Whether or not the cell is highlighted
   */
  highlighted: PropTypes__default['default'].bool,

  /**
   * Whether or not the start of the highlighted cells
   */
  highlightStart: PropTypes__default['default'].bool,

  /**
   * Bordered mode
   */
  bordered: PropTypes__default['default'].bool,

  /**
   * The override API
   */
  overrides: PropTypes__default['default'].shape({
    Td: PropTypes__default['default'].shape({
      styles: PropTypes__default['default'].func,
      component: PropTypes__default['default'].elementType,
      attributes: PropTypes__default['default'].func
    })
  })
};
var defaultProps$2 = {
  highlighted: false,
  highlightStart: false
};
Td$1.defaultProps = defaultProps$2;

var _excluded$e = ["state"];
// Component
// ==============================

var Td = function Td(_ref) {
  _ref.state;
      var rest = _objectWithoutProperties(_ref, _excluded$e);

  return core.jsx("td", rest);
};
// Styles
// ==============================


var tdStyles = function tdStyles(_, _ref3) {
  var highlighted = _ref3.highlighted,
      highlightStart = _ref3.highlightStart,
      bordered = _ref3.bordered;

  var _useBrand = core.useBrand(),
      COLORS = _useBrand.COLORS,
      TYPE = _useBrand.TYPE;

  return {
    label: core.getLabel('table-td'),
    padding: '0.75rem',
    verticalAlign: 'top',
    border: bordered ? "1px solid ".concat(COLORS.border) : 'none',
    borderLeft: highlightStart && "6px solid ".concat(COLORS.primary),
    borderBottom: highlighted && "3px solid ".concat(COLORS.primary),
    //a11y: highlighted border must be noticeably thicker than non-highlighted
    // bold scope
    '&[scope=row]': _objectSpread({}, TYPE.bodyFont[700])
  };
}; // ==============================
// Attributes
// ==============================

var tdAttributes = function tdAttributes() {
  return null;
};
// Exports
// ==============================


var defaultTd = {
  component: Td,
  styles: tdStyles,
  attributes: tdAttributes
};

var _excluded$d = ["state"];
// Component
// ==============================

var TFoot = function TFoot(_ref) {
  _ref.state;
      var rest = _objectWithoutProperties(_ref, _excluded$d);

  return core.jsx("tfoot", rest);
}; // ==============================
// Styles
// ==============================


var tfootStyles = function tfootStyles(_, _ref2) {
  var bordered = _ref2.bordered;

  var _useBrand = core.useBrand(),
      COLORS = _useBrand.COLORS;

  return {
    label: core.getLabel('table-tfoot'),
    color: COLORS.muted,
    'th, tr, td': {
      borderBottom: !bordered ? "0" : "1px solid ".concat(COLORS.border)
    }
  };
}; // ==============================
// Attributes
// ==============================

var tfootAttributes = function tfootAttributes() {
  return null;
}; // ==============================
// Exports
// ==============================


var defaultTfoot = {
  component: TFoot,
  styles: tfootStyles,
  attributes: tfootAttributes
};

var _excluded$c = ["state"];
// Component
// ==============================

var Th$1 = function Th(_ref) {
  _ref.state;
      var rest = _objectWithoutProperties(_ref, _excluded$c);

  return core.jsx("th", rest);
}; // ==============================
// Styles
// ==============================


var thStyles = function thStyles(_, _ref2) {
  var bordered = _ref2.bordered;

  var _useBrand = core.useBrand(),
      COLORS = _useBrand.COLORS;

  return {
    label: core.getLabel('table-th'),
    padding: '0.75rem',
    verticalAlign: 'top',
    border: "1px solid ".concat(COLORS.border),
    borderLeft: !bordered ? 0 : "1px solid ".concat(COLORS.border),
    borderRight: !bordered ? 0 : "1px solid ".concat(COLORS.border),
    textAlign: 'left'
  };
}; // ==============================
// Attributes
// ==============================

var thAttributes = function thAttributes() {
  return null;
}; // ==============================
// Exports
// ==============================


var defaultTh = {
  component: Th$1,
  styles: thStyles,
  attributes: thAttributes
};

var _excluded$b = ["state"];
// Component
// ==============================

var Thead$1 = function Thead(_ref) {
  _ref.state;
      var rest = _objectWithoutProperties(_ref, _excluded$b);

  return core.jsx("thead", rest);
}; // ==============================
// Styles
// ==============================


var theadStyles = function theadStyles(_, _ref2) {
  var bordered = _ref2.bordered;

  var _useBrand = core.useBrand(),
      COLORS = _useBrand.COLORS,
      TYPE = _useBrand.TYPE;

  return {
    label: core.getLabel('table-thead'),
    'th, td': {
      borderTop: !bordered ? 0 : "1px solid ".concat(COLORS.border)
    },
    // `th` cells in the `thead`
    th: _objectSpread({
      verticalAlign: 'bottom',
      borderBottom: "".concat(bordered ? '2px' : '3px', " solid ").concat(COLORS.hero),
      color: COLORS.text
    }, TYPE.bodyFont[700])
  };
}; // ==============================
// Attributes
// ==============================

var theadAttributes = function theadAttributes() {
  return null;
}; // ==============================
// Exports
// ==============================


var defaultThead = {
  component: Thead$1,
  styles: theadStyles,
  attributes: theadAttributes
};

var _excluded$a = ["state"];
// Component
// ==============================

var Table$1 = function Table(_ref) {
  _ref.state;
      var rest = _objectWithoutProperties(_ref, _excluded$a);

  return core.jsx(body.Body, _extends({
    tag: "table"
  }, rest));
};
// Styles
// ==============================


var tableStyles = function tableStyles(_, _ref3) {
  var striped = _ref3.striped;

  var _useBrand = core.useBrand(),
      COLORS = _useBrand.COLORS,
      SPACING = _useBrand.SPACING;

  return {
    label: core.getLabel('table'),
    width: '100%',
    maxWidth: '100%',
    marginBottom: SPACING(4),
    backgroundColor: '#fff',
    borderCollapse: 'collapse',
    // Odd row
    'tbody > tr:nth-of-type(even)': {
      backgroundColor: striped && COLORS.light,
      ':hover': {
        // for blender
        backgroundColor: striped && COLORS.light
      }
    },
    // for blender
    'tbody > tr:nth-of-type(odd):hover': {
      backgroundColor: striped && 'transparent'
    },
    'tbody > tr': {
      transition: !striped ? 'background 0.2s ease' : 'none',
      ':hover': {
        backgroundColor: !striped && COLORS.background
      }
    },
    // Adjacent `tbody` elements
    'tbody + tbody': {
      borderTop: "2px solid ".concat(COLORS.hero)
    }
  };
}; // ==============================
// Attributes
// ==============================


var tableAttributes = function tableAttributes() {
  return null;
};
// Exports
// ==============================


var defaultTable = {
  component: Table$1,
  styles: tableStyles,
  attributes: tableAttributes
};

var _excluded$9 = ["striped", "bordered", "children", "overrides"];
// Context and Consumer Hook
// ==============================

var TableContext = /*#__PURE__*/react.createContext();
var useTableContext = function useTableContext() {
  var context = react.useContext(TableContext);

  if (!context) {
    throw new Error('Table sub-components should be wrapped in a <Table>.');
  }

  return context;
}; // ==============================
// Component
// ==============================

var Table = function Table(_ref) {
  var striped = _ref.striped,
      bordered = _ref.bordered,
      children = _ref.children,
      componentOverrides = _ref.overrides,
      rest = _objectWithoutProperties(_ref, _excluded$9);

  var context = react.useContext(TableContext);
  bordered = context && context.bordered || bordered;

  var _useBrand = core.useBrand(),
      tokenOverrides = _useBrand.OVERRIDES[pkg.name],
      brandOverrides = _useBrand[pkg.name];

  var defaultOverrides = {
    Wrapper: defaultWrapper,
    Table: defaultTable
  };

  var state = _objectSpread({
    striped: striped,
    bordered: bordered,
    overrides: componentOverrides
  }, rest);

  var _overrideReconciler = core.overrideReconciler(defaultOverrides, tokenOverrides, brandOverrides, componentOverrides),
      _overrideReconciler$W = _overrideReconciler.Wrapper,
      Wrapper = _overrideReconciler$W.component,
      wrapperStyles = _overrideReconciler$W.styles,
      wrapperAttributes = _overrideReconciler$W.attributes,
      _overrideReconciler$T = _overrideReconciler.Table,
      Table = _overrideReconciler$T.component,
      tableStyles = _overrideReconciler$T.styles,
      tableAttributes = _overrideReconciler$T.attributes;

  return core.jsx(TableContext.Provider, {
    value: {
      striped: striped,
      bordered: bordered,
      state: state
    }
  }, core.jsx(Wrapper, _extends({
    state: state
  }, wrapperAttributes(state), {
    css: wrapperStyles(state)
  }), core.jsx(Table, _extends({}, rest, {
    state: state
  }, tableAttributes(state), {
    css: tableStyles(state)
  }), children)));
}; // ==============================
// Types
// ==============================

Table.propTypes = {
  /**
   * Striped mode
   */
  striped: PropTypes__default['default'].bool,

  /**
   * Bordered mode
   */
  bordered: PropTypes__default['default'].bool,

  /**
   * The override API
   */
  overrides: PropTypes__default['default'].shape({
    Table: PropTypes__default['default'].shape({
      styles: PropTypes__default['default'].func,
      component: PropTypes__default['default'].elementType,
      attributes: PropTypes__default['default'].func
    }),
    Caption: PropTypes__default['default'].shape({
      styles: PropTypes__default['default'].func,
      component: PropTypes__default['default'].elementType,
      attributes: PropTypes__default['default'].func
    }),
    Tbody: PropTypes__default['default'].shape({
      styles: PropTypes__default['default'].func,
      component: PropTypes__default['default'].elementType,
      attributes: PropTypes__default['default'].func
    }),
    Td: PropTypes__default['default'].shape({
      styles: PropTypes__default['default'].func,
      component: PropTypes__default['default'].elementType,
      attributes: PropTypes__default['default'].func
    }),
    Tfoot: PropTypes__default['default'].shape({
      styles: PropTypes__default['default'].func,
      component: PropTypes__default['default'].elementType,
      attributes: PropTypes__default['default'].func
    }),
    Th: PropTypes__default['default'].shape({
      styles: PropTypes__default['default'].func,
      component: PropTypes__default['default'].elementType,
      attributes: PropTypes__default['default'].func
    }),
    Thead: PropTypes__default['default'].shape({
      styles: PropTypes__default['default'].func,
      component: PropTypes__default['default'].elementType,
      attributes: PropTypes__default['default'].func
    }),
    Tr: PropTypes__default['default'].shape({
      styles: PropTypes__default['default'].func,
      component: PropTypes__default['default'].elementType,
      attributes: PropTypes__default['default'].func
    })
  })
};
var defaultProps$1 = {
  bordered: false,
  striped: false
};
Table.defaultProps = defaultProps$1;

var _excluded$8 = ["state"];
// Component
// ==============================

var Caption$1 = function Caption(_ref) {
  _ref.state;
      var rest = _objectWithoutProperties(_ref, _excluded$8);

  return core.jsx("caption", rest);
}; // ==============================
// Styles
// ==============================


var captionStyles = function captionStyles() {
  var _useBrand = core.useBrand(),
      TYPE = _useBrand.TYPE;

  return _objectSpread({
    label: core.getLabel('table-caption'),
    fontSize: '1.125rem',
    textAlign: 'left',
    marginBottom: '0.75rem'
  }, TYPE.bodyFont[300]);
}; // ==============================
// Attributes
// ==============================


var captionAttributes = function captionAttributes() {
  return null;
}; // ==============================
// Exports
// ==============================


var defaultCaption = {
  component: Caption$1,
  styles: captionStyles,
  attributes: captionAttributes
};

var _excluded$7 = ["children", "overrides"];
// Component
// ==============================

var Caption = function Caption(_ref) {
  var children = _ref.children,
      overrides = _ref.overrides,
      rest = _objectWithoutProperties(_ref, _excluded$7);

  var _useBrand = core.useBrand(),
      tokenOverrides = _useBrand.OVERRIDES[pkg.name],
      brandOverrides = _useBrand[pkg.name];

  var context = useTableContext();
  var defaultOverrides = {
    Caption: defaultCaption
  };
  var componentOverrides = overrides || context.state.overrides;

  var state = _objectSpread({
    context: context.state,
    overrides: componentOverrides
  }, rest);

  var _overrideReconciler = core.overrideReconciler(defaultOverrides, tokenOverrides, brandOverrides, componentOverrides),
      _overrideReconciler$C = _overrideReconciler.Caption,
      Caption = _overrideReconciler$C.component,
      CaptionStyles = _overrideReconciler$C.styles,
      CaptionAttributes = _overrideReconciler$C.attributes;

  return core.jsx(Caption, _extends({}, rest, {
    state: state
  }, CaptionAttributes(state), {
    css: CaptionStyles(state)
  }), children);
}; // ==============================
// Types
// ==============================

Caption.propTypes = {
  /**
   * The override API
   */
  overrides: PropTypes__default['default'].shape({
    Caption: PropTypes__default['default'].shape({
      styles: PropTypes__default['default'].func,
      component: PropTypes__default['default'].elementType,
      attributes: PropTypes__default['default'].func
    })
  })
};

var _excluded$6 = ["bordered", "children", "overrides"];
// Component
// ==============================

var Thead = function Thead(_ref) {
  var bordered = _ref.bordered,
      children = _ref.children,
      overrides = _ref.overrides,
      rest = _objectWithoutProperties(_ref, _excluded$6);

  var _useBrand = core.useBrand(),
      tokenOverrides = _useBrand.OVERRIDES[pkg.name],
      brandOverrides = _useBrand[pkg.name];

  var context = useTableContext();
  bordered = context && context.bordered || bordered;
  var defaultOverrides = {
    Thead: defaultThead
  };
  var componentOverrides = overrides || context.state.overrides;

  var state = _objectSpread({
    bordered: bordered,
    context: context.state,
    overrides: componentOverrides
  }, rest);

  var _overrideReconciler = core.overrideReconciler(defaultOverrides, tokenOverrides, brandOverrides, componentOverrides),
      _overrideReconciler$T = _overrideReconciler.Thead,
      Thead = _overrideReconciler$T.component,
      theadStyles = _overrideReconciler$T.styles,
      theadAttributes = _overrideReconciler$T.attributes;

  return core.jsx(Thead, _extends({}, rest, {
    state: state
  }, theadAttributes(state), {
    css: theadStyles(state)
  }), children);
}; // ==============================
// Types
// ==============================

Thead.propTypes = {
  /**
   * Whether or not there should border styling
   */
  bordered: PropTypes__default['default'].bool,

  /**
   * The override API
   */
  overrides: PropTypes__default['default'].shape({
    Thead: PropTypes__default['default'].shape({
      styles: PropTypes__default['default'].func,
      component: PropTypes__default['default'].elementType,
      attributes: PropTypes__default['default'].func
    })
  })
};

var _excluded$5 = ["state"];
// Component
// ==============================

var Tr$1 = function Tr(_ref) {
  _ref.state;
      var rest = _objectWithoutProperties(_ref, _excluded$5);

  return core.jsx("tr", rest);
};
// Styles
// ==============================


var trStyles = function trStyles(_, _ref3) {
  var highlighted = _ref3.highlighted;

  var _useBrand = core.useBrand(),
      COLORS = _useBrand.COLORS;

  return {
    label: core.getLabel('table-tr'),
    borderLeft: typeof highlighted === 'boolean' && highlighted ? "6px solid ".concat(COLORS.primary) : 0,
    borderBottom: typeof highlighted === 'boolean' && highlighted ? "3px solid ".concat(COLORS.primary) : "1px solid ".concat(COLORS.border) //a11y: highlighted border must be noticeably thicker than non-highlighted

  };
}; // ==============================
// Attributes
// ==============================


var trAttributes = function trAttributes() {
  return null;
};
// Exports
// ==============================


var defaultTr = {
  component: Tr$1,
  styles: trStyles,
  attributes: trAttributes
};

var _excluded$4 = ["striped", "highlighted", "children", "overrides"];
// Utils
// ==============================

var generateHighlightMap = function generateHighlightMap(highlighted, tdCount) {
  var map = Array(tdCount).fill(false);
  highlighted.forEach(function (highlight) {
    if (typeof highlight === 'number') {
      map[highlight] = true;
    } else if (Array.isArray(highlight)) {
      map.fill(true, highlight[0], highlight[1] + 1);
    }
  });
  return map;
}; // ==============================
// Component
// ==============================


var Tr = function Tr(_ref) {
  var striped = _ref.striped,
      highlighted = _ref.highlighted,
      children = _ref.children,
      overrides = _ref.overrides,
      rest = _objectWithoutProperties(_ref, _excluded$4);

  var _useBrand = core.useBrand(),
      tokenOverrides = _useBrand.OVERRIDES[pkg.name],
      brandOverrides = _useBrand[pkg.name];

  var context = useTableContext();
  striped = context && context.striped || striped;
  var defaultOverrides = {
    Tr: defaultTr
  };
  var componentOverrides = overrides || context.state.overrides;

  var state = _objectSpread({
    striped: striped,
    highlighted: highlighted,
    context: context.state,
    overrides: componentOverrides
  }, rest);

  var _overrideReconciler = core.overrideReconciler(defaultOverrides, tokenOverrides, brandOverrides, componentOverrides),
      _overrideReconciler$T = _overrideReconciler.Tr,
      Tr = _overrideReconciler$T.component,
      trStyles = _overrideReconciler$T.styles,
      trAttributes = _overrideReconciler$T.attributes;

  var highlightedChildren;

  if (Array.isArray(highlighted)) {
    var highlightMap = generateHighlightMap(highlighted, react.Children.count(children));
    highlightedChildren = react.Children.map(children, function (child, index) {
      if (highlightMap[index] === true) {
        if (index === 0 || highlightMap[index - 1] === false) {
          return /*#__PURE__*/react.cloneElement(child, {
            highlightStart: true,
            highlighted: true
          });
        } else {
          return /*#__PURE__*/react.cloneElement(child, {
            highlighted: true
          });
        }
      } else {
        return child;
      }
    });
  }

  return core.jsx(Tr, _extends({}, rest, {
    state: state
  }, trAttributes(state), {
    css: trStyles(state)
  }), highlightedChildren || children);
}; // ==============================
// Types
// ==============================

Tr.propTypes = {
  /**
   * Highlighted mode
   */
  highlighted: PropTypes__default['default'].oneOfType([PropTypes__default['default'].bool, PropTypes__default['default'].array]),

  /**
   * The override API
   */
  overrides: PropTypes__default['default'].shape({
    Tr: PropTypes__default['default'].shape({
      styles: PropTypes__default['default'].func,
      component: PropTypes__default['default'].elementType,
      attributes: PropTypes__default['default'].func
    })
  })
};
var defaultProps = {
  highlighted: false
};
Tr.defaultProps = defaultProps;

var _excluded$3 = ["bordered", "children", "overrides"];
// Component
// ==============================

var Th = function Th(_ref) {
  var bordered = _ref.bordered,
      children = _ref.children,
      overrides = _ref.overrides,
      rest = _objectWithoutProperties(_ref, _excluded$3);

  var _useBrand = core.useBrand(),
      tokenOverrides = _useBrand.OVERRIDES[pkg.name],
      brandOverrides = _useBrand[pkg.name];

  var context = useTableContext();
  bordered = context && context.bordered || bordered;
  var defaultOverrides = {
    Th: defaultTh
  };
  var componentOverrides = overrides || context.state.overrides;

  var state = _objectSpread({
    bordered: bordered,
    context: context.state,
    overrides: componentOverrides
  }, rest);

  var _overrideReconciler = core.overrideReconciler(defaultOverrides, tokenOverrides, brandOverrides, componentOverrides),
      _overrideReconciler$T = _overrideReconciler.Th,
      Th = _overrideReconciler$T.component,
      thStyles = _overrideReconciler$T.styles,
      thAttributes = _overrideReconciler$T.attributes;

  return core.jsx(Th, _extends({}, rest, {
    state: state
  }, thAttributes(state), {
    css: thStyles(state)
  }), children);
}; // ==============================
// Types
// ==============================

Th.propTypes = {
  /**
   * Whether or not there should border styling
   */
  bordered: PropTypes__default['default'].bool,

  /**
   * The override API
   */
  overrides: PropTypes__default['default'].shape({
    Th: PropTypes__default['default'].shape({
      styles: PropTypes__default['default'].func,
      component: PropTypes__default['default'].elementType,
      attributes: PropTypes__default['default'].func
    })
  })
};

var _excluded$2 = ["state"];
// Component
// ==============================

var Tbody$1 = function Tbody(_ref) {
  _ref.state;
      var rest = _objectWithoutProperties(_ref, _excluded$2);

  return core.jsx("tbody", rest);
}; // ==============================
// Styles
// ==============================


var tbodyStyles = function tbodyStyles() {
  return {
    label: core.getLabel('table-tbody')
  };
}; // ==============================
// Attributes
// ==============================


var tbodyAttributes = function tbodyAttributes() {
  return null;
}; // ==============================
// Exports
// ==============================


var defaultTBody = {
  component: Tbody$1,
  styles: tbodyStyles,
  attributes: tbodyAttributes
};

var _excluded$1 = ["children", "overrides"];
// Component
// ==============================

var Tbody = function Tbody(_ref) {
  var children = _ref.children,
      overrides = _ref.overrides,
      rest = _objectWithoutProperties(_ref, _excluded$1);

  var _useBrand = core.useBrand(),
      tokenOverrides = _useBrand.OVERRIDES[pkg.name],
      brandOverrides = _useBrand[pkg.name];

  var context = useTableContext();
  var defaultOverrides = {
    Tbody: defaultTBody
  };
  var componentOverrides = overrides || context.state.overrides;

  var state = _objectSpread({
    context: context.state,
    overrides: componentOverrides
  }, rest);

  var _overrideReconciler = core.overrideReconciler(defaultOverrides, tokenOverrides, brandOverrides, componentOverrides),
      _overrideReconciler$T = _overrideReconciler.Tbody,
      Tbody = _overrideReconciler$T.component,
      tbodyStyles = _overrideReconciler$T.styles,
      tbodyAttributes = _overrideReconciler$T.attributes;

  return core.jsx(Tbody, _extends({}, rest, {
    state: state
  }, tbodyAttributes(state), {
    css: tbodyStyles(state)
  }), children);
}; // ==============================
// Types
// ==============================

Tbody.propTypes = {
  /**
   * The override API
   */
  overrides: PropTypes__default['default'].shape({
    Tbody: PropTypes__default['default'].shape({
      styles: PropTypes__default['default'].func,
      component: PropTypes__default['default'].elementType,
      attributes: PropTypes__default['default'].func
    })
  })
};

var _excluded = ["bordered", "children", "overrides"];
// Component
// ==============================

var Tfoot = function Tfoot(_ref) {
  var bordered = _ref.bordered,
      children = _ref.children,
      overrides = _ref.overrides,
      rest = _objectWithoutProperties(_ref, _excluded);

  var _useBrand = core.useBrand(),
      tokenOverrides = _useBrand.OVERRIDES[pkg.name],
      brandOverrides = _useBrand[pkg.name];

  var context = useTableContext();
  bordered = context && context.bordered || bordered;
  var defaultOverrides = {
    Tfoot: defaultTfoot
  };
  var componentOverrides = overrides || context.state.overrides;

  var state = _objectSpread({
    bordered: bordered,
    context: context.state,
    overrides: componentOverrides
  }, rest);

  var _overrideReconciler = core.overrideReconciler(defaultOverrides, tokenOverrides, brandOverrides, componentOverrides),
      _overrideReconciler$T = _overrideReconciler.Tfoot,
      Tfoot = _overrideReconciler$T.component,
      tfootStyles = _overrideReconciler$T.styles,
      tfootAttributes = _overrideReconciler$T.attributes;

  return core.jsx(Tfoot, _extends({}, rest, {
    state: state
  }, tfootAttributes(state), {
    css: tfootStyles(state)
  }), children);
}; // ==============================
// Types
// ==============================

Tfoot.propTypes = {
  /**
   * Whether or not there should border styling
   */
  bordered: PropTypes__default['default'].bool,

  /**
   * The override API
   */
  overrides: PropTypes__default['default'].shape({
    Tfoot: PropTypes__default['default'].shape({
      styles: PropTypes__default['default'].func,
      component: PropTypes__default['default'].elementType,
      attributes: PropTypes__default['default'].func
    })
  })
};

exports.Caption = Caption;
exports.Table = Table;
exports.Tbody = Tbody;
exports.Td = Td$1;
exports.Tfoot = Tfoot;
exports.Th = Th;
exports.Thead = Thead;
exports.Tr = Tr;
